#!/usr/bin/perl
# vp 14.02.2018 erstellt

die <<HELP unless @ARGV;
Aufruf: bin2jtc bin-file [Dateiname] [aadr] 
konvertiert bin-Dateien ins JTC-Format
aadr als Hexazahl, Standard E000
Dateiname max. 8.3-Format (Dos), Standard ist bin-file

bin2jtc.pl 4krom_vp1.bin TINY4K.SYS 0
HELP


#Dateiname
if ($ARGV[1] ne '') { $name = $ARGV[1] } 
else {  $name = $ARGV[0]; 
	$name =~ s/\.[^.]+$//; # remove the extension
}

# Programmname auf 8.3 trimmen
$name =~ s{^.*[\\/]}{};     # remove the leading path  

$name=uc $name;


#aadr
if ($ARGV[2] ne '') { $aadr = oct '0x'.$ARGV[2] } else { $aadr =  0x0E000 }
$size= -s $ARGV[0];
$eadr = $aadr + $size-1;
printf "NAME=%s AADR=%.4X EADR=%.4X\n", $name, $aadr, $eadr;

# Datei erstellen

$OUT = $name;

open IN, "<$ARGV[0]";
binmode IN;

open OUT, ">$OUT";
binmode OUT;

print "Schreibe $OUT ";


#KC-Header
print OUT pack("
	A11		   # dateiname: array[0..7] of char;
	xxxxx		   # empty bytes
	c		   # anzpara: byte;
	sss		   # aadr, eadr, sadr: word;
	x		   # sby: byte;
	", $name, 2, $aadr, $eadr, 0
);

print OUT "\x00"x(128-24);  # 1. Block fr MC mit 00 auffllen

#Daten schreiben
until (eof IN) {
	read IN, $block, 128; 
	if (eof (IN)) { $blocknr = 255 }	# der letzte Block erhlt die Nr. FF
	# print OUT pack("C",$blocknr++);
	print OUT pack("a128", $block);
}

close IN;
close OUT;
